#include <iostream.h>
#include <string.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>

enum tag {Single, Pair};

struct LispEl
{
  tag Tag;
  union
  {
   char Leaf; //.
   struct     // .
   {
     char Oper;
     LispEl* Left;
     LispEl* Right;
   } Pr;
  };
};

class Tree
{
  private:
	 LispEl* Root; //   .
  public:
	 void PrintTree (LispEl*, int);
	 void Enter (LispEl**, int&, char *);
	 LispEl** GetTree() { return &Root; };
	 LispEl* GetTree1() { return Root; };
	 float Operation (char, float, float);
	 float Evalbintree (LispEl *);
	 Tree () { Root = NULL; };
};

// ------------    ----------
float Tree::Operation (char Symbol, float Operand_1, float Operand_2)
{
  float temp;

  switch (Symbol)
  {
	 case '+': temp = Operand_1 + Operand_2; break;
	 case '-': temp = Operand_1 - Operand_2; break;
	 case '*': temp = Operand_1 * Operand_2; break;
	 case '/': temp = Operand_1 / Operand_2; break;
	 case '^': temp = exp (Operand_2 * log(Operand_1));
  }
  return temp;
}

float Tree::Evalbintree (LispEl *T)
{
  float opnd1,opnd2,rez=0;
  char  symb,tmp[2];

  tmp[1]='\0';

  if (T!=NULL)
  {
	if (T->Tag==Pair)
	{
	  opnd1 = Evalbintree (T->Pr.Left);
	  opnd2 = Evalbintree (T->Pr.Right);
	  symb  = T->Pr.Oper;
	  rez =  Operation (symb,opnd1,opnd2);
	}
	else
	{
	  tmp[0] = T->Leaf;
	  rez = atoi (tmp);
	}
  return rez;
  }
}

void Tree::PrintTree (LispEl* W, int l)
// p p,   p W.
{
  int i;

  if  (W->Tag!=Single)
  {
	  PrintTree (W->Pr.Right,l+1);
	  for (i=1;i<=l;i++) cout << "   ";
	  cout << W->Pr.Oper << endl;
	  PrintTree (W->Pr.Left,l+1);
  }
  else
  {
	  for (i=1;i<=l;i++) cout << "   ";
	  cout << W->Leaf << endl;
  }
}

void Tree::Enter (LispEl** T, int& i, char *Str)
//p p p,
// S-p  LISP.
{
  char X;

  X = Str[i]; i++;
  //   p X  p p.
  if (strchr("0123456789",X)==NULL)
  {
	(*T) = new (LispEl);
	(**T).Tag = Pair;
	(*T)->Pr.Oper = X;
	Enter (&((*T)->Pr.Left),i,Str);
	Enter (&((*T)->Pr.Right),i,Str);
  }
  else
  {
	(*T) = new (LispEl);
	(**T).Tag = Single; (*T)->Leaf = X;
  }
}

void main()
{
  char Str[23];    //p  p p.
  char Result[23]; //p   p.
  int i=0;         // p.

  Tree C;

  cout << "p p p  p \n";
  cout << "   ...\n";
  cout << "  ... \n";
  gets (Str);
  C.Enter (C.GetTree(),i,Str);
  cout << endl;
  C.PrintTree (C.GetTree1(),0);
  cout << "\n ---------------------------------------- \n";
  cout << "   p...\n";
  cout << C.Evalbintree (C.GetTree1());
}
